Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.1.1.3.4.1.4.1
retrieving revision 1.1.1.3.4.1.4.2
diff -u -r1.1.1.3.4.1.4.1 -r1.1.1.3.4.1.4.2
--- squid/src/cf.data.pre	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.1
+++ squid/src/cf.data.pre	3 May 2000 19:22:26 -0000	1.1.1.3.4.1.4.2
@@ -2300,8 +2252,6 @@
 	Average object size, used to estimate number of objects your
 	cache can hold.  See doc/Release-Notes-1.1.txt.  The default is
 	13 KB.
-
-store_avg_object_size 13 KB
 DOC_END
 
 NAME: store_objects_per_bucket
@@ -2312,8 +2262,6 @@
 	Target number of objects per bucket in the store hash table.
 	Lowering this value increases the total number of buckets and
 	also the storage maintenance rate.  The default is 50.
-
-store_objects_per_bucket 20
 DOC_END
 
 NAME: client_db
@@ -2324,8 +2272,6 @@
 DOC_START
 	If you want to disable collecting per-client statistics, then
 	turn off client_db here.
-
-client_db on
 DOC_END
 
 
@@ -2344,9 +2290,6 @@
 	database.  These are counts, not percents.  The defaults are
 	900 and 1000.  When the high water mark is reached, database
 	entries will be deleted until the low mark is reached.
-
-netdb_low 900
-netdb_high 1000
 DOC_END
 
 
@@ -2358,8 +2301,6 @@
 	The minimum period for measuring a site.  There will be at
 	least this much delay between successive pings to the same
 	network.  The default is five minutes.
-
-netdb_ping_period 5 minutes
 DOC_END
 
 
@@ -2380,8 +2321,6 @@
 	the minimal RTT to the origin server.  When this happens, the
 	hierarchy field of the access.log will be
 	"CLOSEST_PARENT_MISS".  This option is off by default.
-
-query_icmp off
 DOC_END
 
 NAME: test_reachability
@@ -2393,8 +2332,6 @@
 	When this is 'on', ICP MISS replies will be ICP_MISS_NOFETCH
 	instead of ICP_MISS if the target host is NOT in the ICMP
 	database, or has a zero RTT.
-
-test_reachability off
 DOC_END
 
 NAME: buffered_logs
@@ -2408,7 +2345,6 @@
 	unbuffered.  By default they will be unbuffered. Buffering them
 	can speed up the writing slightly (though you are unlikely to
 	need to worry).
-buffered_logs off
 DOC_END
 
 NAME: reload_into_ims
@@ -2428,7 +2364,6 @@
 
 	This option may be disabled by using --disable-http-violations
 	with the configure script.
-reload_into_ims off
 DOC_END
 
 NAME: always_direct
@@ -2539,8 +2474,6 @@
 
 	By default, all headers are allowed (no anonymizing is
 	performed).
-
-anonymize_headers
 DOC_END
 
 NAME: fake_user_agent
@@ -2554,8 +2487,6 @@
 
 	fake_user_agent Nutscrape/1.0 (CP/M; 8-bit)
 	(credit to Paul Southworth pauls@etext.org for this one!)
-
-fake_user_agent none
 DOC_END
 
 NAME: icon_directory
@@ -2598,8 +2529,6 @@
 	minimum value, is five seconds, and the maximum value is sixty
 	seconds, or half of connect_timeout, whichever is greater and
 	less than connect_timeout.
-
-minimum_retry_timeout 5 seconds
 DOC_END
 
 NAME: maximum_single_addr_tries
@@ -2614,8 +2543,6 @@
 	The default value is three tries, the (not recommended)
 	maximum is 255 tries.  A warning message will be generated
 	if it is set to a value greater than ten.
-
-maximum_single_addr_tries 3
 DOC_END
 
 NAME: snmp_port
@@ -2630,7 +2557,6 @@
 
 	NOTE: SNMP support requires use the --enable-snmp configure
 	command line option.
-snmp_port 3401
 DOC_END
 
 NAME: snmp_access
@@ -2648,8 +2574,8 @@
 	snmp_access allow|deny [!]aclname ...
 
 Example:
-snmp_access allow snmppublic localhost
-snmp_access deny all
+ snmp_access allow snmppublic localhost
+ snmp_access deny all
 DOC_END
 
 NAME: snmp_incoming_address
@@ -2671,13 +2597,16 @@
 	snmp_outgoing_address	is used for SNMP packets returned to SNMP
 				agents.
 
-	The default behavior is to not bind to any specific address.
+	The default snmp_incoming_address (0.0.0.0) is to listen on all
+	available network interfaces.
 
-	NOTE, snmp_incoming_address and snmp_outgoing_address can not have
-	the same value since they both use port 3130.
+	If snmp_outgoing_address is set to 255.255.255.255 (the default)
+	then it will use the same socket as snmp_incoming_address. Only
+	change this if you want to have SNMP replies sent using another
+	address than where this Squid listens for SNMP queries.
 
-snmp_incoming_address 0.0.0.0
-snmp_outgoing_address 0.0.0.0
+	NOTE, snmp_incoming_address and snmp_outgoing_address can not have
+	the same value since they both use port 3401.
 DOC_END
 
 NAME: as_whois_server
@@ -2699,7 +2628,6 @@
 	Use this option to define your WCCP ``home'' router for
 	Squid.   Setting the 'wccp_router' to 0.0.0.0 (the default)
 	disables WCCP.
-wccp_router 0.0.0.0
 DOC_END
 
 NAME: wccp_incoming_address
@@ -2732,9 +2660,6 @@
 
         NOTE, wccp_incoming_address and wccp_outgoing_address can not have
         the same value since they both use port 2048.
-
-wccp_incoming_address 0.0.0.0
-wccp_outgoing_address 0.0.0.0
 DOC_END
 
 
@@ -2755,7 +2680,6 @@
 
 	To enable this option, you must use --enable-delay-pools with the
 	configure script.
-delay_pools 0
 DOC_END
 
 NAME: delay_class
@@ -2769,9 +2693,10 @@
 	delay pools, one of class 2 and one of class 3, the settings above
 	and here would be:
 
-delay_pools 2      # 2 delay pools
-delay_class 1 2    # pool 1 is a class 2 pool
-delay_class 2 3    # pool 2 is a class 3 pool
+Example:
+ delay_pools 2      # 2 delay pools
+ delay_class 1 2    # pool 1 is a class 2 pool
+ delay_class 2 3    # pool 2 is a class 3 pool
 
 	The delay pool classes are:
 
@@ -2807,10 +2732,11 @@
 	all been checked.  For example, if you want some_big_clients in delay
 	pool 1 and lotsa_little_clients in delay pool 2:
 
-delay_access 1 allow some_big_clients
-delay_access 1 deny all
-delay_access 2 allow lotsa_little_clients
-delay_access 2 deny all
+Example:
+ delay_access 1 allow some_big_clients
+ delay_access 1 deny all
+ delay_access 2 allow lotsa_little_clients
+ delay_access 2 deny all
 DOC_END
 
 NAME: delay_parameters
@@ -2886,8 +2812,6 @@
 	a host accessing it (in class 2 and class 3, individual hosts and
 	networks only have buckets associated with them once they have been
 	"seen" by squid).
-
-delay_initial_bucket_level 50
 DOC_END
 
 NAME: incoming_icp_average
@@ -2916,18 +2840,19 @@
 	Heavy voodoo here.  I can't even believe you are reading this.
 	Are you crazy?  Don't even think about adjusting these unless
 	you understand the algorithms in comm_select.c first!
-
-incoming_icp_average 6
-incoming_http_average 4
-min_icp_poll_cnt 8
-min_http_poll_cnt 8
 DOC_END
 
 NAME: max_open_disk_fds
 TYPE: int
 LOC: Config.max_open_disk_fds
 DEFAULT: 0
-DOC_NONE
+DOC_START
+	To avoid having disk as the I/O bottleneck Squid can optionally
+	bypass the on-disk cache if more than this amount of disk file
+	descriptors are open.
+
+	A value of 0 indicates no limit.
+DOC_END
 
 NAME: offline_mode
 TYPE: onoff
@@ -2961,7 +2886,6 @@
 	chop:	The request is allowed and the URI is chopped at the
 		first whitespace.  This might also be considered a
 		violation.
-uri_whitespace strip
 DOC_END
 
 NAME: broken_posts
@@ -2982,8 +2906,9 @@
 	  forbidden by the BNF, an HTTP/1.1 client must not preface or follow
 	  a request with an extra CRLF.
 
-acl buggy_server url_regex ^http://....
-broken_posts allow buggy_server
+Example:
+ acl buggy_server url_regex ^http://....
+ broken_posts allow buggy_server
 DOC_END
 
 NAME: mcast_miss_addr
@@ -3030,19 +2955,38 @@
 	encrypted.  This is the encryption key.
 DOC_END
 
+NAME: nonhierarchical_direct
+TYPE: onoff
+LOC: Config.onoff.nonhierarchical_direct
+DEFAULT: on
+DOC_START
+	By default, Squid will send any non-hierarchical requests
+	(matching hierarchy_stoplist or not cachable request type) direct
+	to origin servers.
+
+	If you set this to off, then Squid will prefer to send these
+	requests to parents.
+
+	Note that in most configurations, by turning this off you will only
+	add latency to these request without any improvement in global hit
+	ratio.
+
+	If you are inside an firewall then see never_direct instead of
+	this directive.
+DOC_END
+
 NAME: prefer_direct
 TYPE: onoff
 LOC: Config.onoff.prefer_direct
-DEFAULT: on
+DEFAULT: off
 DOC_START
-	By default, if the ICP, HTCP, Cache Digest, etc. techniques
-	do not yield a parent cache, Squid gives higher preference
-	to forwarding the request direct to origin servers, rather
-	than selecting a parent cache anyway.
-
-	If you want Squid to give higher precedence to a parent
-	cache, instead of going direct, then turn this option off.
-prefer_direct on
+	Normally Squid tries to use parents for most requests. If you by some
+	reason like it to first try going direct and only use a parent if
+	going direct fails then set this to off.
+
+	By combining nonhierarchical_direct off and prefer_direct on you
+	can set up Squid to use a parent as a backup path if going direct
+	fails.
 DOC_END
 
 NAME: strip_query_terms
@@ -3052,7 +2996,6 @@
 DOC_START
 	By default, Squid strips query terms from requested URLs before
 	logging.  This protects your user's privacy.
-strip_query_terms on
 DOC_END
 
 NAME: coredump_dir
@@ -3092,7 +3035,6 @@
 	don't match, Squid ignores the response and writes a warning
 	message to cache.log.  You can allow responses from unknown
 	nameservers by setting this option to 'off'.
-ignore_unknown_nameservers on
 DOC_END
 
 NAME: digest_generation
@@ -3104,7 +3046,6 @@
 	This controls whether the server will generate a Cache Digest
 	of its contents.  By default, Cache Digest generation is
 	enabled if Squid is compiled with USE_CACHE_DIGESTS defined.
-digest_generation on
 DOC_END
 
 NAME: digest_bits_per_entry
@@ -3116,7 +3057,6 @@
 	This is the number of bits of the server's Cache Digest which
 	will be associated with the Digest entry for a given HTTP
 	Method and URL (public key) combination.  The default is 5.
-digest_bits_per_entry 5
 DOC_END
 
 NAME: digest_rebuild_period
@@ -3127,8 +3067,6 @@
 DEFAULT: 1 hour
 DOC_START
 	This is the number of seconds between Cache Digest rebuilds.
-	By default the server's Digest is rebuilt every hour.
-digest_rebuild_period 1 hour
 DOC_END
 
 NAME: digest_rewrite_period
@@ -3139,9 +3077,7 @@
 DEFAULT: 1 hour
 DOC_START
 	This is the number of seconds between Cache Digest writes to
-	disk.  By default the server's Digest is written to disk every
-	hour.
-digest_rewrite_period 1 hour
+	disk.
 DOC_END
 
 NAME: digest_swapout_chunk_size
@@ -3154,7 +3090,6 @@
 	This is the number of bytes of the Cache Digest to write to
 	disk at a time.  It defaults to 4096 bytes (4KB), the Squid
 	default swap page.
-digest_swapout_chunk_size 4096 bytes
 DOC_END
 
 NAME: digest_rebuild_chunk_percentage
@@ -3166,7 +3101,6 @@
 DOC_START
 	This is the percentage of the Cache Digest to be scanned at a
 	time.  By default it is set to 10% of the Cache Digest.
-digest_rebuild_chunk_percentage 10
 DOC_END
 
 NAME: chroot
@@ -3196,8 +3130,6 @@
 	default, Squid uses persistent connections (when allowed)
 	with its clients and servers.  You can use these options to
 	disable persistent connections with clients and/or servers.
-client_persistent_connections on
-server_persistent_connections on
 DOC_END
 
 NAME: diskd_magic1
@@ -3212,7 +3144,9 @@
 TYPE: int
 LOC: Config.diskd.magic2
 DEFAULT: 72
-DOC_NONE
+DOC_START
+	Macic constants for the diskd daemon..
+DOC_END
 
 EOF
 
Index: squid/src/cf_gen.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf_gen.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/cf_gen.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/cf_gen.c	3 May 2000 19:22:26 -0000	1.1.1.3.8.2
@@ -1,5 +1,5 @@
 /*
- * $Id: cf_gen.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: cf_gen.c,v 1.1.1.3.8.2 2000/05/03 19:22:26 hno Exp $
  *
  * DEBUG: none
  * AUTHOR: Max Okumoto
@@ -48,6 +48,7 @@
  *****************************************************************************/
 
 #include "config.h"
+#include "cf_gen_defines.h"
 
 #if HAVE_STDIO_H
 #include <stdio.h>
@@ -89,7 +90,7 @@
     char *type;
     char *loc;
     char *default_value;
-    char *default_if_none;
+    Line *default_if_none;
     char *comment;
     char *ifdef;
     Line *doc;
@@ -106,6 +107,14 @@
 static void gen_conf(Entry *, FILE *);
 static void gen_default_if_none(Entry *, FILE *);
 
+static void lineAdd(Line **L, char *str)
+{
+    while(*L)
+    	L = &(*L)->next;
+    *L=xcalloc(1, sizeof(Line));
+    (*L)->data = xstrdup(str);
+}
+
 int
 main(int argc, char *argv[])
 {
@@ -189,7 +198,7 @@
 		ptr = buff + 16;
 		while (xisspace(*ptr))
 		    ptr++;
-		curr->default_if_none = xstrdup(ptr);
+		lineAdd(&curr->default_if_none, ptr);
 	    } else if (!strncmp(buff, "LOC:", 4)) {
 		if ((ptr = strtok(buff + 4, WS)) == NULL) {
 		    printf("Error on line %d\n", linenum);
@@ -396,6 +405,7 @@
 gen_default_if_none(Entry * head, FILE * fp)
 {
     Entry *entry;
+    Line *line;
     fprintf(fp,
 	"static void\n"
 	"defaults_if_none(void)\n"
@@ -408,15 +418,20 @@
 	    continue;
 	if (entry->ifdef)
 	    fprintf(fp, "#if %s\n", entry->ifdef);
-	fprintf(fp,
-	    "\tif (check_null_%s(%s))\n"
-	    "\t\tdefault_line(\"%s %s\");\n",
-	    entry->type,
-	    entry->loc,
-	    entry->name,
-	    entry->default_if_none);
+	if (entry->default_if_none) {
+	    fprintf(fp,
+		"\tif (check_null_%s(%s)) {\n",
+		entry->type,
+		entry->loc);
+	    for (line = entry->default_if_none; line; line = line->next)
+		fprintf(fp,
+		    "\t\tdefault_line(\"%s %s\");\n",
+		    entry->name,
+		    line->data);
+	    fprintf(fp, "\t}\n");
+	}
 	if (entry->ifdef)
-	    fprintf(fp, "#endif\n");
+	fprintf(fp, "#endif\n");
     }
     fprintf(fp, "}\n\n");
 }
@@ -520,13 +535,37 @@
     fprintf(fp, "}\n\n");
 }
 
+static int defined(char *name)
+{
+	int i=0;
+	if (!name)
+	    return 1;
+	for(i=0;strcmp(defines[i].name, name) != 0; i++) {
+	    assert(defines[i].name);
+	}
+	return defines[i].defined;
+}
+
+static const char *available_if(char *name)
+{
+	int i=0;
+	assert(name);
+	for(i=0;strcmp(defines[i].name, name) != 0; i++) {
+	    assert(defines[i].name);
+	}
+	return defines[i].enable;
+}
+
 static void
 gen_conf(Entry * head, FILE * fp)
 {
     Entry *entry;
+    char buf[8192];
+    Line *def = NULL;
 
     for (entry = head; entry != NULL; entry = entry->next) {
 	Line *line;
+	int blank = 1;
 
 	if (!strcmp(entry->name, "comment"))
 	    (void) 0;
@@ -535,9 +574,43 @@
 	if (entry->comment)
 	    fprintf(fp, "\t%s", entry->comment);
 	fprintf(fp, "\n");
+	if (!defined(entry->ifdef)) {
+	    fprintf(fp, "# Note: This option is only available if Squid is rebuilt with the\n");
+	    fprintf(fp, "#       %s option\n#\n", available_if(entry->ifdef));
+	}
 	for (line = entry->doc; line != NULL; line = line->next) {
 	    fprintf(fp, "#%s\n", line->data);
 	}
+	if (entry->default_value && strcmp(entry->default_value,"none") != 0) {
+	    sprintf(buf, "%s %s", entry->name, entry->default_value);
+	    lineAdd(&def, buf);
+	}
+	if (entry->default_if_none) {
+	    for (line = entry->default_if_none; line; line = line->next) {
+		sprintf(buf, "%s %s", entry->name, line->data);
+		lineAdd(&def, buf);
+	    }
+	}
+	if (entry->nocomment)
+	    blank = 0;
+	if (!def && entry->doc && !entry->nocomment &&
+		strcmp(entry->name, "comment") != 0)
+	    lineAdd(&def, "none");
+	if (def && (entry->doc || entry->nocomment)) {
+	    if (blank)
+		fprintf(fp, "#\n");
+	    fprintf(fp, "#Default:\n");
+	    while (def != NULL) {
+		line = def;
+		def = line->next;
+		fprintf(fp, "# %s\n", line->data);
+		free(line->data);
+		free(line);
+	    }
+	    blank=1;
+	}
+	if (entry->nocomment && blank)
+	    fprintf(fp, "#\n");
 	for (line = entry->nocomment; line != NULL; line = line->next) {
 	    fprintf(fp, "%s\n", line->data);
 	}
Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.1.1.3.4.1.4.2
retrieving revision 1.1.1.3.4.1.4.3
diff -u -r1.1.1.3.4.1.4.2 -r1.1.1.3.4.1.4.3
--- squid/src/client_side.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.2
+++ squid/src/client_side.c	3 May 2000 19:22:26 -0000	1.1.1.3.4.1.4.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_side.c,v 1.1.1.3.4.1.4.2 2000/04/16 23:59:17 hno Exp $
+ * $Id: client_side.c,v 1.1.1.3.4.1.4.3 2000/05/03 19:22:26 hno Exp $
  *
  * DEBUG: section 33    Client-side Routines
  * AUTHOR: Duane Wessels
@@ -87,6 +87,8 @@
 static clientHttpRequest *parseHttpRequestAbort(ConnStateData * conn, const char *uri);
 static clientHttpRequest *parseHttpRequest(ConnStateData *, method_t *, int *, char **, size_t *);
 static RH clientRedirectDone;
+static void clientCheckNoCache(clientHttpRequest *);
+static void clientCheckNoCacheDone(int answer, void *data);
 static STCB clientHandleIMSReply;
 static int clientGetsOldEntry(StoreEntry * new, StoreEntry * old, request_t * request);
 static int checkAccelOnly(clientHttpRequest *);
@@ -139,16 +141,12 @@
 }
 #endif
 
-void
-clientAccessCheck(void *data)
+static aclCheck_t *
+clientAclChecklistCreate(const acl_access *acl, const clientHttpRequest *http)
 {
-    clientHttpRequest *http = data;
+    aclCheck_t *ch;
     ConnStateData *conn = http->conn;
-    if (checkAccelOnly(http)) {
-	clientAccessCheckDone(ACCESS_ALLOWED, http);
-	return;
-    }
-    http->acl_checklist = aclChecklistCreate(Config.accessList.http,
+    ch = aclChecklistCreate(acl,
 	http->request,
 	conn->ident);
 #if USE_IDENT
@@ -156,9 +154,21 @@
      * hack for ident ACL. It needs to get full addresses, and a
      * place to store the ident result on persistent connections...
      */
-    http->acl_checklist->conn = conn;
-    cbdataLock(http->acl_checklist->conn);
+    ch->conn = conn;
+    cbdataLock(ch->conn);
 #endif
+    return ch;
+}
+
+void
+clientAccessCheck(void *data)
+{
+    clientHttpRequest *http = data;
+    if (checkAccelOnly(http)) {
+	clientAccessCheckDone(ACCESS_ALLOWED, http);
+	return;
+    }
+    http->acl_checklist = clientAclChecklistCreate(Config.accessList.http, http);
     aclNBCheck(http->acl_checklist, clientAccessCheckDone, http);
 }
 
@@ -296,6 +306,26 @@
     headersLog(0, 1, request->method, request);
 #endif
     fd_note(http->conn->fd, http->uri);
+    clientCheckNoCache(http);
+}
+
+static void
+clientCheckNoCache(clientHttpRequest * http)
+{
+    if (Config.accessList.noCache && http->request->flags.cachable) {
+	http->acl_checklist = clientAclChecklistCreate(Config.accessList.noCache, http);
+	aclNBCheck(http->acl_checklist, clientCheckNoCacheDone, http);
+    } else {
+	clientCheckNoCacheDone(http->request->flags.cachable, http);
+    }
+}
+
+void
+clientCheckNoCacheDone(int answer, void *data)
+{
+    clientHttpRequest *http = data;
+    http->request->flags.cachable = answer;
+    http->acl_checklist = NULL;
     clientProcessRequest(http);
 }
 
@@ -543,6 +573,8 @@
 	return;
     }
     http->log_type = LOG_TCP_MISS;
+    /* Release both IP and object cache entries */
+    ipcacheInvalidate(http->request->host);
     if ((entry = storeGetPublic(http->uri, METHOD_GET)) == NULL) {
 	http->http_code = HTTP_NOT_FOUND;
     } else {
@@ -649,11 +681,18 @@
     MemObject *mem = NULL;
     debug(33, 3) ("httpRequestFree: %s\n", storeUrl(http->entry));
     if (!clientCheckTransferDone(http)) {
+#if MYSTERIOUS_CODE
+	/*
+	 * DW: this seems odd here, is it really needed?  It causes
+	 * incomplete transfers to get logged with "000" status
+	 * code because http->entry becomes NULL.
+	 */
 	if ((e = http->entry)) {
 	    http->entry = NULL;
 	    storeUnregister(e, http);
 	    storeUnlockObject(e);
 	}
+#endif
 	if (http->entry && http->entry->ping_status == PING_WAITING)
 	    storeReleaseRequest(http->entry);
     }
@@ -896,28 +935,6 @@
     const char *url = http->uri;
     request_t *req = http->request;
     method_t method = req->method;
-    aclCheck_t ch;
-    memset(&ch, '\0', sizeof(ch));
-    /*
-     * Hopefully, nobody really wants 'no_cache' by client's IP
-     * address, but if they do, this should work if they use IP
-     * addresses in their ACLs, or if the client's address is in
-     * the FQDN cache.
-     *
-     * This may not work yet for 'dst' and 'dst_domain' ACLs.
-     */
-    ch.src_addr = http->conn->peer.sin_addr;
-    ch.my_addr = http->conn->me.sin_addr;
-    ch.my_port = ntohs(http->conn->me.sin_port);
-    ch.request = http->request;
-    /*
-     * aclCheckFast returns 1 for ALLOW and 0 for DENY.  The default
-     * is ALLOW, so we require 'no_cache DENY foo' in squid.conf
-     * to indicate uncachable objects.
-     */
-    if (Config.accessList.noCache)
-	if (!aclCheckFast(Config.accessList.noCache, &ch))
-	    return 0;
     if (req->protocol == PROTO_HTTP)
 	return httpCachable(method);
     /* FTP is always cachable */
@@ -1068,7 +1085,9 @@
 {
     HttpHeader *hdr = rep ? &rep->header : 0;
     const char *range_err = NULL;
-    assert(http->request->range);
+    request_t *request = http->request;
+    int is_hit = isTcpHit(http->log_type);
+    assert(request->range);
     /* check if we still want to do ranges */
     if (!rep)
 	range_err = "no [parse-able] reply";
@@ -1086,6 +1105,11 @@
 	range_err = "canonization failed";
     else if (httpHdrRangeIsComplex(http->request->range))
 	range_err = "too complex range header";
+    else if (!request->flags.cachable) /* from we_do_ranges in http.c */
+	range_err = "non-cachable request";
+    else if (!is_hit && Config.rangeOffsetLimit < httpHdrRangeFirstOffset(request->range)
+	    && Config.rangeOffsetLimit != -1) /* from we_do_ranges in http.c */
+	range_err = "range outside range_offset_limit";
     /* get rid of our range specs on error */
     if (range_err) {
 	debug(33, 3) ("clientBuildRangeHeader: will not do ranges: %s.\n", range_err);
@@ -2693,6 +2717,13 @@
 	/* We can generate a HEAD reply from a cached GET object */
 	e = http->entry = storeGetPublic(http->uri, METHOD_GET);
     }
+    /* Release negatively cached IP-cache entries on reload */
+    if (r->flags.nocache)
+	ipcacheReleaseInvalid(r->host);
+#if HTTP_VIOLATIONS
+    else if (r->flags.nocache_hack)
+	ipcacheReleaseInvalid(r->host);
+#endif
 #if USE_CACHE_DIGESTS
     http->lookup_type = e ? "HIT" : "MISS";
 #endif
@@ -2718,12 +2749,6 @@
 	return LOG_TCP_HIT;
     }
 #if HTTP_VIOLATIONS
-    if (r->flags.nocache_hack) {
-	/* if nocache_hack is set, nocache should always be clear, right? */
-	assert(!r->flags.nocache);
-	ipcacheReleaseInvalid(r->host);
-	/* continue! */
-    }
     if (e->store_status == STORE_PENDING) {
 	if (r->flags.nocache || r->flags.nocache_hack) {
 	    debug(33, 3) ("Clearing no-cache for STORE_PENDING request\n\t%s\n",
Index: squid/src/comm_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm_select.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/comm_select.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/comm_select.c	3 May 2000 19:22:26 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm_select.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: comm_select.c,v 1.1.1.3.8.2 2000/05/03 19:22:26 hno Exp $
  *
  * DEBUG: section 5     Socket Functions
  *
@@ -34,13 +34,7 @@
 
 #include "squid.h"
 
-#if USE_ASYNC_IO
-#define MAX_POLL_TIME 10
-#elif USE_DISKD
-#define MAX_POLL_TIME 10
-#else
-#define MAX_POLL_TIME 1000
-#endif
+static int MAX_POLL_TIME = 1000; /* see also comm_quick_poll_required() */
 
 #ifndef        howmany
 #define howmany(x, y)   (((x)+((y)-1))/(y))
@@ -332,12 +326,8 @@
 	getCurrentTime();
 	start = current_dtime;
 #endif
-#if USE_ASYNC_IO
-	aioCheckCallbacks();
-#endif
-#if USE_DISKD
-	storeDiskdReadQueue();
-#endif
+    /* Handle any fs callbacks that need doing */
+    storeDirCallback();
 #if DELAY_POOLS
 	FD_ZERO(&slowfds);
 #endif
@@ -645,6 +635,7 @@
     fd_set slowfds;
 #endif
     PF *hdl = NULL;
+    SwapDir *SD;
     int fd;
     int maxfd;
     int num;
@@ -662,19 +653,16 @@
     struct timeval poll_time;
     double timeout = current_dtime + (msec / 1000.0);
     fde *F;
+    int i;
     do {
 #if !ALARM_UPDATES_TIME
 	getCurrentTime();
 #endif
-#if USE_ASYNC_IO
-	aioCheckCallbacks();
-#endif
-#if USE_DISKD
-	storeDiskdReadQueue();
-#endif
 #if DELAY_POOLS
 	FD_ZERO(&slowfds);
 #endif
+        /* Handle any fs callbacks that need doing */
+        storeDirCallback();
 	if (commCheckICPIncoming)
 	    comm_select_icp_incoming();
 	if (commCheckDNSIncoming)
@@ -1090,3 +1078,10 @@
 	nwritefds--;
     }
 }
+
+/* Called by async-io or diskd to speed up the polling */
+void
+comm_quick_poll_required(void)
+{
+    MAX_POLL_TIME = 10;
+}
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/defines.h	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/defines.h	3 May 2000 19:22:26 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: defines.h,v 1.1.1.3.8.2 2000/05/03 19:22:26 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -147,7 +147,6 @@
 #define LOG_DISABLE 0
 
 #define SM_PAGE_SIZE 4096
-#define DISK_PAGE_SIZE  8192
 
 #define EBIT_SET(flag, bit) 	((void)((flag) |= ((1L<<(bit)))))
 #define EBIT_CLR(flag, bit) 	((void)((flag) &= ~((1L<<(bit)))))
@@ -270,8 +269,3 @@
 #define _PATH_DEVNULL "/dev/null"
 #endif
 
-#if USE_ASYNC_IO
-#ifndef NUMTHREADS
-#define NUMTHREADS 16
-#endif
-#endif
Index: squid/src/delay_pools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/delay_pools.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/delay_pools.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/delay_pools.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: delay_pools.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: delay_pools.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: David Luyer <luyer@ucs.uwa.edu.au>
@@ -222,18 +222,18 @@
      */
     switch (class) {
     case 1:
-	delay_data[pool].class1->aggregate = (rates->aggregate.max_bytes *
-	    Config.Delay.initial) / 100;
+	delay_data[pool].class1->aggregate = (int)(((double)rates->aggregate.max_bytes *
+	    Config.Delay.initial) / 100);
 	break;
     case 2:
-	delay_data[pool].class2->aggregate = (rates->aggregate.max_bytes *
-	    Config.Delay.initial) / 100;
+	delay_data[pool].class2->aggregate = (int)(((double)rates->aggregate.max_bytes *
+	    Config.Delay.initial) / 100);
 	delay_data[pool].class2->individual_map[0] = 255;
 	delay_data[pool].class2->individual_255_used = 0;
 	break;
     case 3:
-	delay_data[pool].class3->aggregate = (rates->aggregate.max_bytes *
-	    Config.Delay.initial) / 100;
+	delay_data[pool].class3->aggregate = (int)(((double)rates->aggregate.max_bytes *
+	    Config.Delay.initial) / 100);
 	delay_data[pool].class3->network_map[0] = 255;
 	delay_data[pool].class3->network_255_used = 0;
 	memset(&delay_data[pool].class3->individual_255_used, '\0',
@@ -307,8 +307,8 @@
 	    if (!delay_data[pool].class2->individual_255_used) {
 		delay_data[pool].class2->individual_255_used = 1;
 		delay_data[pool].class2->individual[IND_MAP_SZ - 1] =
-		    (Config.Delay.rates[pool]->individual.max_bytes *
-		    Config.Delay.initial) / 100;
+		    (int)(((double)Config.Delay.rates[pool]->individual.max_bytes *
+		    Config.Delay.initial) / 100);
 	    }
 	    return delayId(pool + 1, 255);
 	}
@@ -320,8 +320,8 @@
 		assert(i < (IND_MAP_SZ - 1));
 		delay_data[pool].class2->individual_map[i + 1] = 255;
 		delay_data[pool].class2->individual[i] =
-		    (Config.Delay.rates[pool]->individual.max_bytes *
-		    Config.Delay.initial) / 100;
+		    (int)(((double)Config.Delay.rates[pool]->individual.max_bytes *
+		    Config.Delay.initial) / 100);
 		break;
 	    }
 	}
@@ -336,8 +336,8 @@
 	if (!delay_data[pool].class3->network_255_used) {
 	    delay_data[pool].class3->network_255_used = 1;
 	    delay_data[pool].class3->network[255] =
-		(Config.Delay.rates[pool]->network.max_bytes *
-		Config.Delay.initial) / 100;
+		(int)(((double)Config.Delay.rates[pool]->network.max_bytes *
+		Config.Delay.initial) / 100);
 	}
     } else {
 	for (i = 0; i < NET_MAP_SZ; i++) {
@@ -349,8 +349,8 @@
 		assert(i < (NET_MAP_SZ - 1));
 		delay_data[pool].class3->network_map[i + 1] = 255;
 		delay_data[pool].class3->network[i] =
-		    (Config.Delay.rates[pool]->network.max_bytes *
-		    Config.Delay.initial) / 100;
+		    (int)(((double)Config.Delay.rates[pool]->network.max_bytes *
+		    Config.Delay.initial) / 100);
 		break;
 	    }
 	}
@@ -362,8 +362,8 @@
 	    delay_data[pool].class3->individual_255_used[i / 8] |= (1 << (i % 8));
 	    assert(position < C3_IND_SZ);
 	    delay_data[pool].class3->individual[position] =
-		(Config.Delay.rates[pool]->individual.max_bytes *
-		Config.Delay.initial) / 100;
+		(int)(((double)Config.Delay.rates[pool]->individual.max_bytes *
+		Config.Delay.initial) / 100);
 	}
 	return delayId(pool + 1, position);
     }
@@ -380,8 +380,8 @@
 	    position |= j;
 	    assert(position < C3_IND_SZ);
 	    delay_data[pool].class3->individual[position] =
-		(Config.Delay.rates[pool]->individual.max_bytes *
-		Config.Delay.initial) / 100;
+		(int)(((double)Config.Delay.rates[pool]->individual.max_bytes *
+		Config.Delay.initial) / 100);
 	    break;
 	}
     }
Index: squid/src/disk.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/disk.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/disk.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/disk.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: disk.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: disk.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 6     Disk I/O Routines
  * AUTHOR: Harvest Derived
@@ -187,6 +187,8 @@
     debug(6, 3) ("diskHandleWrite: FD %d writing %d bytes\n",
 	fd, (int) (fdd->write_q->len - fdd->write_q->buf_offset));
     errno = 0;
+    if (fdd->write_q->file_offset != -1)
+        lseek(fd, fdd->write_q->file_offset, SEEK_SET);
     len = write(fd,
 	fdd->write_q->buf + fdd->write_q->buf_offset,
 	fdd->write_q->len - fdd->write_q->buf_offset);
